VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PF_plot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'class: PF_plot
'-------------

' --------------------- plot depended --------------------------------
'public
' methods:
'  show(PictureBox)       - calculate and show radial plot
'  getPlotName()
'  getData() as string    - calculate and return data for radial plot (for save)
'
'private
' methods:
'  Sub Xscale(pic As PictureBox, Label As String, xmin As Single, xmax As Single)
'  Sub Lscale(pic As PictureBox, Label As String, ymin As Single, ymax As Single)
'  Sub Rscale(pic As PictureBox, Label As String, ymin As Single, ymax As Single)
'
'  vars:
   'labels:
   Private Const plotName = "F Test for Significant Peaks"
   Private Const xLabel = "Number of peaks fitted"
   Private Const yLeft = "Probability (%) for F Test"
   Private Const yRight = ""
   'colors:
   Private Const colPF = &HFF0000
   Private Const col5 = &HFF&
'
' --------------------- plot undepended --------------------------------
'private
' methods:
'  Sub init(pic As PictureBox)
'  Function getY0(pic As PictureBox)
'  Function getYY(pic As PictureBox)
'  Function getX0(pic As PictureBox)
'  Function getXX(pic As PictureBox)
'  Sub drawTitle(pic As PictureBox, name As String)
'  Sub drawAxis(pic As PictureBox)
'  Sub setScale(pic As PictureBox, x0 As Single, xx As Single, y0 As Single, yy As Single)
'
'  vars:
   Private mode As Integer   'plot Mode
   'colors:
   Private Const colBack = &H80000005
   Private Const colFill = &H80000005
   'font:
   Private Const Font = "Times New Roman"
   Private Const screenFontSize = 10
   Private Const printFontSize = 14
   Private hFont As Single
   'window:
   Private psize As Single
   Private dh2 As Single
   Private dw2 As Single
   Private Const cScreen = 3
   Private Const cCopy = 2
   Private Const cPrint = 4
   Private Const cTopScreen = 0.17
   Private Const cTopCopy = 0.25
   Private Const cTopPrint = 0.38
'

'------------------------ plot depended methods --------------------------------
'
Public Function getPlotName() As String
  getPlotName = plotName
End Function

Public Function getData() As String
  Dim ss As String
  Dim i As Integer
  
  ss = "Maximum number of fitted peaks = " + Str(PkNum) + vbCrLf
  ss = ss + "Number_of_FittedPeaks, P(F)(%)" + vbCrLf
  For i = 1 To PkNum
    ss = ss + Str(peaks(i).count) + nFormat(peaks(i).pF, 2, 10) + vbCrLf
  Next i
  getData = ss
End Function

Private Sub Xscale(pic As PictureBox)
  Dim i As Integer, dd As Single, cy As Single, ss As String

  dd = 0.25 * hFont
  cy = getY0(pic)
  For i = getX0(pic) To getXX(pic)
    pic.Line (i, cy)-(i, cy - dd)
    ss = Format(i)
    pic.CurrentX = i - 0.6 * pic.TextWidth(ss)
    pic.CurrentY = cy - dd
    pic.Print ss
  Next i
End Sub

' log scale
Private Sub Lscale(pic As PictureBox, ByVal ymin As Single, ByVal ymax As Single)
  Dim i As Integer, dy As Single
  Dim dd As Single, dh As Single, cx As Single, cy As Single
  Dim yText As New Rotator
  Dim ss As String

  dd = 0.5 * Abs(pic.TextWidth("0"))
  dh = 0.5 * pic.TextHeight("0")
  cx = getX0(pic)
  dy = 100
  For i = 1 To 10
    cy = Log10(dy)
    pic.Line (cx - dd, cy)-(cx, cy)
    ss = Format(Round(10 ^ cy, 1))
    pic.CurrentX = cx - dd - pic.TextWidth(ss + " ")
    pic.CurrentY = cy - dh
    pic.Print ss
    dy = dy / 2
  Next
End Sub

' log scale
Private Sub Rscale(pic As PictureBox, ByVal ymin As Single, ByVal ymax As Single)
  Dim i As Integer, dy As Single
  Dim dd As Single, dh As Single, cx As Single, cy As Single
  Dim yText As New Rotator
  Dim ss As String

  dd = 0.5 * Abs(pic.TextWidth("0"))
  dh = 0.5 * pic.TextHeight("0")
  cx = getXX(pic)
  dy = 100
  For i = 1 To 10
    cy = Log10(dy)
    pic.Line (cx, cy)-(cx + dd, cy)
    ss = Format(Round(10 ^ cy, 1))
    pic.CurrentX = cx + dd + pic.TextWidth(" ")
    pic.CurrentY = cy - dh
    pic.Print ss
    dy = dy / 2
  Next
End Sub

Public Sub show(ByRef pic As PictureBox, plotMode As Integer)
  Dim i As Integer, n As Integer, r As Single, rx As Single, ry As Single
  Dim x0 As Single, xx As Single, y0 As Single, yy As Single

  mode = plotMode   ' 0-Screen, 1-Copy, 2-Print
  init pic
  If mode = 2 Then drawTitle pic, plotName
  drawAxis pic
'MsgBox pkAutoCalc
  x0 = 1
  n = PkNum
'  If isAuto = 1 Then n = n + 1
  If isAuto = 1 Then n = pkAutoCalc
  xx = PkNum + 1
  If xx < 3 Then xx = 3
  y0 = Log10(0.1)
  yy = Log10(100)
  setScale pic, x0, xx, y0, yy
  Lscale pic, y0, yy
  Rscale pic, y0, yy
  Xscale pic

  If n > 1 Then
    Dim col As Single, style As Single, dw As Single, md As Integer
    Dim dd As Single, dh As Single
    dw = pic.DrawWidth
    style = pic.FillStyle
    col = pic.FillColor
    pic.DrawWidth = dw * 2
    pic.FillStyle = vbFSSolid
    For i = 2 To n
      yy = peaks(i).pF
      If yy < 0.1 Then yy = 0.1
      yy = Log10(yy)
      pic.Line (i - 1, y0)-(i, yy), colPF
      y0 = yy
    Next i
    pic.DrawWidth = dw

    r = pic.ScaleWidth / 70
    ry = pic.ScaleHeight / 140
    rx = 0.5 * r
    md = 0
    For i = 2 To n
      yy = peaks(i).pF
      If yy < 0.1 Then yy = 0.1
      yy = Log10(yy)
      pic.FillColor = colFill
      pic.Circle (i, yy), r ', colPF
      If Round(peaks(i).pF) > 5 Then
        If i > 2 And md = 0 Then
          pic.FillColor = colPF
          pic.Circle (i - 1, y0), r
          md = 1
        End If
        pic.FillColor = colFill
        pic.Circle (i, yy), r, colFill
        pic.DrawWidth = dw * 1.5
        pic.Line (i - rx, yy - ry)-(i + rx, yy + ry)
        pic.Line (i - rx, yy + ry)-(i + rx, yy - ry)
        pic.DrawWidth = dw
      End If
      y0 = yy
    Next i
    pic.FillColor = col
    pic.FillStyle = style
  End If

  yy = Log10(5)
  pic.Line (x0, yy)-(xx, yy), col5
End Sub

'------------------------ plot undepended methods --------------------------------

Private Sub init(pic As PictureBox)
  Dim hh As Single

  pic.Cls
  pic.Font = Font
  If mode = 0 Then
    pic.Font.Size = screenFontSize
  Else
    pic.Font.Size = printFontSize
  End If
  pic.FillStyle = 0
  pic.BackColor = colBack
  pic.FillColor = colFill
  pic.ScaleMode = 0    'custom
  pic.Scale (0, pic.Height)-(pic.Width, 0)
  hh = Abs(pic.ScaleHeight)
  hFont = Abs(pic.TextHeight("0"))
  If mode = 0 Then                                  'screen
    psize = hh - cScreen * hFont
  ElseIf mode = 1 Then                              'copy
    psize = hh - cCopy * hFont
  ElseIf mode = 2 Then                              'print
    psize = hh - cPrint * hFont
  End If
  dh2 = (hh - psize) / hh
  dw2 = (pic.ScaleWidth - psize) / pic.ScaleWidth
End Sub
  
Private Function getY0(pic As PictureBox)
  Dim hh As Single

  hh = Abs(pic.ScaleHeight)
  If mode = 0 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopScreen)
  ElseIf mode = 1 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopCopy)
  ElseIf mode = 2 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopPrint)
  End If
End Function

Private Function getYY(pic As PictureBox)
  Dim hh As Single

  hh = Abs(pic.ScaleHeight)
  If mode = 0 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopScreen
  ElseIf mode = 1 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopCopy
  ElseIf mode = 2 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopPrint
  End If
End Function

Private Function getX0(pic As PictureBox)
  getX0 = pic.ScaleLeft + (pic.ScaleWidth * dw2) / 2
End Function

Private Function getXX(pic As PictureBox)
  getXX = pic.ScaleLeft + pic.ScaleWidth - (pic.ScaleWidth * dw2) / 2
End Function

Private Sub drawTitle(pic As PictureBox, name As String)
  pic.Font.Size = 1.1 * printFontSize
  pic.Font.Bold = True
  pic.CurrentX = (pic.ScaleWidth - pic.TextWidth(name)) / 2
  pic.CurrentY = pic.ScaleTop
  pic.Print name
  pic.Font.Size = printFontSize
  pic.Font.Bold = False
End Sub

Private Sub drawAxis(pic As PictureBox)
  Dim yText As New Rotator

  pic.Line (getX0(pic), getY0(pic))-(getXX(pic), getYY(pic)), , B
  If mode <> 1 Then
    'X
    pic.CurrentX = pic.ScaleLeft + (pic.ScaleWidth - pic.TextWidth(xLabel)) / 2
    pic.CurrentY = 1.2 * hFont
    pic.Print xLabel
    ' Left
    Set yText.Device = pic
    yText.Angle = 90
    pic.CurrentY = getY0(pic) + (psize - pic.TextWidth(yLeft)) / 2
    pic.CurrentX = 0.2 * hFont
    yText.Label yLeft
    ' Right
    Set yText.Device = pic
    yText.Angle = 90
    pic.CurrentY = getY0(pic) + (psize - pic.TextWidth(yRight)) / 2
    pic.CurrentX = pic.ScaleWidth - 1.2 * hFont
    yText.Label yRight
  End If
End Sub

Private Sub setScale(pic As PictureBox, ByVal x0 As Single, ByVal xx As Single, ByVal y0 As Single, ByVal yy As Single)
  Dim dx As Single, dy As Single

  dx = (xx - x0) * dw2 / (1 - dw2)
  dy = (yy - y0) * dh2 / (1 - dh2)
  If mode = 0 Then
    pic.Scale (x0 - dx / 2, yy + cTopScreen * dy)-(xx + dx / 2, y0 - (1 - cTopScreen) * dy)
  ElseIf mode = 1 Then
    pic.Scale (x0 - dx / 2, yy + cTopCopy * dy)-(xx + dx / 2, y0 - (1 - cTopCopy) * dy)
  ElseIf mode = 2 Then
    pic.Scale (x0 - dx / 2, yy + cTopPrint * dy)-(xx + dx / 2, y0 - (1 - cTopPrint) * dy)
  End If
  hFont = Abs(pic.TextHeight("0"))
End Sub

