VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Rotator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'ROTATOR.CLS
Option Explicit

'API constants
Private Const LF_FACESIZE = 32
Private Const LOGPIXELSY = 90

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lsngStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lsngPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 1) As Byte
End Type

Private Declare Function SelectObject _
Lib "gdi32" ( _
    ByVal hdc As Long, _
    ByVal hObject As Long _
) As Long

Private Declare Function DeleteObject _
Lib "gdi32" ( _
    ByVal hObject As Long _
) As Long

Private Declare Function CreateFontIndirect _
Lib "gdi32" Alias "CreateFontIndirectA" ( _
    lpLogFont As LOGFONT _
) As Long

Private Declare Function TextOut _
Lib "gdi32" Alias "TextOutA" ( _
    ByVal hdc As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal lpString As String, _
    ByVal nCount As Long _
) As Long

Private Declare Function GetDeviceCaps _
Lib "gdi32" ( _
    ByVal hdc As Long, _
    ByVal intIndex As Long _
) As Long

'Module-level private variables
Private mobjDevice As Object
Private msngSX1 As Single
Private msngSY1 As Single
Private msngXRatio As Single
Private msngYRatio As Single
Private mlfFont As LOGFONT
Private mintAngle As Integer

'~~~Angle
Property Let Angle(intAngle As Integer)
    mintAngle = intAngle
End Property
Property Get Angle() As Integer
    Angle = mintAngle
End Property

'~~~Label
Public Sub Label(sText As String)
    Dim lngFont As Long
    Dim lngOldFont As Long
    Dim lngRes As Long
    Dim bytBuf() As Byte
    Dim intI As Integer
    Dim strFontName As String
    'Prepare font name, decoding from Unicode
    strFontName = mobjDevice.Font.name
    bytBuf = StrConv(strFontName & Chr$(0), vbFromUnicode)
    For intI = 0 To UBound(bytBuf)
        mlfFont.lfFaceName(intI) = bytBuf(intI)
    Next intI
    'Convert known font size to required units
    mlfFont.lfHeight = mobjDevice.Font.Size * _
        GetDeviceCaps(mobjDevice.hdc, LOGPIXELSY) \ 64 '72
    'Set Italic or not
    If mobjDevice.Font.Italic = True Then
        mlfFont.lfItalic = 1
    Else
        mlfFont.lfItalic = 0
    End If
    'Set Underline or not
    If mobjDevice.Font.Underline = True Then
        mlfFont.lfUnderline = 1
    Else
        mlfFont.lfUnderline = 0
    End If
    'Set Strikethrough or not
    If mobjDevice.Font.Strikethrough = True Then
        mlfFont.lsngStrikeOut = 1
    Else
        mlfFont.lsngStrikeOut = 0
    End If
    'Set Bold or not (use font's weight)
    mlfFont.lfWeight = mobjDevice.Font.Weight
    'Set font rotation angle
    mlfFont.lfEscapement = CLng(mintAngle * 10#)
    mlfFont.lfOrientation = mlfFont.lfEscapement
    'Build temporary new font and output the string
    lngFont = CreateFontIndirect(mlfFont)
    lngOldFont = SelectObject(mobjDevice.hdc, lngFont)
    lngRes = TextOut(mobjDevice.hdc, XtoP(mobjDevice.CurrentX), _
        YtoP(mobjDevice.CurrentY), sText, Len(sText))
    lngFont = SelectObject(mobjDevice.hdc, lngOldFont)
    DeleteObject lngFont
End Sub

'~~~Device
Property Set Device(objDevice As Object)
    Dim sngSX2 As Single
    Dim sngSY2 As Single
    Dim sngPX2 As Single
    Dim sngPY2 As Single
    Dim intScaleMode As Integer
    Set mobjDevice = objDevice
    With mobjDevice
        'Grab current scaling parameters
        intScaleMode = .ScaleMode
        msngSX1 = .ScaleLeft
        msngSY1 = .ScaleTop
        sngSX2 = msngSX1 + .ScaleWidth
        sngSY2 = msngSY1 + .ScaleHeight
        'Temporarily set pixels mode
        .ScaleMode = vbPixels
        'Grab pixel scaling parameters
        sngPX2 = .ScaleWidth
        sngPY2 = .ScaleHeight
        'Reset user's original scale
        If intScaleMode = 0 Then
            mobjDevice.Scale (msngSX1, msngSY1)-(sngSX2, sngSY2)
        Else
            mobjDevice.ScaleMode = intScaleMode
        End If
        'Calculate scaling ratios just once
        msngXRatio = sngPX2 / (sngSX2 - msngSX1)
        msngYRatio = sngPY2 / (sngSY2 - msngSY1)
    End With
End Property

'Scales X value to pixel location
Private Function XtoP(sngX As Single) As Long
    XtoP = (sngX - msngSX1) * msngXRatio
End Function

'Scales Y value to pixel location
Private Function YtoP(sngY As Single) As Long
    YtoP = (sngY - msngSY1) * msngYRatio
End Function

