Attribute VB_Name = "dPrint"
' see '!!!
' handle the error in printData (err vaiable)

Option Explicit

Private printMode As Integer   '0-printer, 1-screen
Private fLabel As String
Private line As Integer
Private ERR As Integer
Private page As Integer

Private pr As Object
Private dWidth As Single
Private dHeight As Single
Private wx0 As Single
Private wy0 As Single
Private ww As Single
Private wh As Single
Private cx As Single
Private cy As Single
Private hTitle As Single

Private fTitle As String
Private fsTitle As Single
Private fParam As String
Private fsParam As Single
Private fGrain As String
Private fsGrain As Single


Private RhoD0 As Single
Private RERhoD0 As Single
Private Uglass0 As Single
Private Zeta0 As Single
Private REZeta0 As Single
Private SqSize As Single
Private ZMethodFlag As Integer

Private Ns(maxGrains) As Single, Ni(maxGrains) As Single, Sq(maxGrains) As Single
Private FTage(maxGrains) As Single, FTerrL(maxGrains) As Single, FTerrU(maxGrains) As Single
Private Zgrain(maxGrains) As Single, Zerr(maxGrains) As Single
Private Zeta(maxGrains) As Single, REZeta(maxGrains) As Single
Private RhoD(maxGrains) As Single, RERhoD(maxGrains) As Single
Private RhoS(maxGrains) As Single, RhoI(maxGrains) As Single, Uglass(maxGrains) As Single
Private PkAge(maxPeaks) As Single, PkF(maxPeaks) As Single

Public Sub printResult(mode As Integer)
  If Num > 0 Then
    '... set printMode to 0 for default printer output, and 1 for preview screen for testing
    printMode = 0
    If printMode = 0 Then
      Set pr = Printer
    Else
      Set pr = PrintPreview.pr
      PrintPreview.show
    End If
    ERR = 0
    init
    If mode = 1 Or mode = 3 Then printData
    If mode = 2 Or mode = 3 Then printPlots
    If printMode = 0 Then pr.EndDoc
  End If
End Sub

Private Sub printData()
  hTitle = newPage()
  line = 2
  printParams
  printGrains
  printResults
End Sub

Private Sub init()
  dWidth = 0.8
  dHeight = 0.9

  pr.ScaleMode = 1
  ww = pr.ScaleWidth * dWidth
  wh = pr.ScaleHeight * dHeight
  wx0 = pr.ScaleWidth * (1 - dWidth) / 2
  wy0 = pr.ScaleHeight * (1 - dHeight) / 2

  pr.Scale (-wx0, -wy0)-(ww + wx0, wh + wy0)
  fTitle = "Times New Roman"
  fsTitle = 10
  fParam = "Courier"
  fsParam = 10
  fGrain = "Courier"
  fsGrain = 10
  line = 1
  page = 0
  ERR = 0
  cx = 0
  cy = 0
End Sub

Private Sub sPrint(ss As String, ByVal x As Single, ByVal y As Single)
  pr.CurrentX = x
  pr.CurrentY = y
  pr.Print ss
  cx = x + pr.TextWidth(ss)
  cy = y + pr.TextHeight(ss)
End Sub

Private Function printTitle() As Integer
  Dim hText As Single, y0 As Single, y As Single
  Dim ss As String, i As Integer, ff As String, fs As Single

  ff = pr.Font
  fs = pr.FontSize
  pr.Font = fTitle
  pr.FontSize = fsTitle
  hText = pr.TextHeight("0")
  fLabel = data.getLine(1)
  
  y0 = cy
  pr.FontItalic = True
  y = cy
  sPrint Format(Date, "mmmm d yyyy") + "  " + Format(Time, "Short Time"), 0, y
  ss = APP.title + " ver." + Format(APP.Major) + "." + Format(APP.Minor)
  sPrint ss, (ww - pr.TextWidth(ss)) / 2, y
  ss = "Page" + Str(page)
  sPrint ss, ww - pr.TextWidth(ss), y
  pr.FontItalic = False
  cy = cy + 0.1 * hText
  If data.fCount = 1 Then
    sPrint "Datafile: " + data.fName(1), 0, cy
    sPrint "Title: " + data.fTitle(1), 0, cy
    If data.remCount > 0 Then
      sPrint "Edited datafile (total grains deleted =" + Str(data.remCount) + ")", 0, cy
    End If
  Else
    If data.remCount = 0 Then Call sPrint("Merged dataset:", 0, cy) Else Call sPrint("Merged and edited dataset:", 0, cy)
    For i = 1 To data.fCount
      sPrint "   " + data.fName(i), 0, cy
    Next i
    If data.remCount > 0 Then sPrint "Total grains deleted =" + Str(data.remCount), 0, cy
  End If
  pr.Line (0, cy)-(ww, cy)
  cy = cy + 2 * hText
  printTitle = cy - y0
  pr.Font = ff
  pr.FontSize = fs
End Function

Private Sub printGTitle(x As Single)
  Dim ss As String, y As Integer

  sPrint "Grain    RhoS    (Ns)     RhoI    (Ni)  Squares  U+/-2s    Grain Age (Ma)", x, cy
  y = cy
  ss = " no.    (cm^-2)          (cm^-2)                          Age     --95% CI--"
  sPrint ss, x, cy
  pr.Line (cx - pr.TextWidth("0") * 20, y)-(cx, y)
  pr.Line (x, cy)-(pr.TextWidth(ss), cy)
  cy = cy + 0.3 * pr.TextHeight("0")
End Sub

Private Function newPage() As Single
  page = page + 1
  If printMode = 0 Then
    If page > 1 Then pr.newPage
  Else
    If page > 1 Then MsgBox "Page " + Str(page)
    pr.Cls
  End If
  cy = wy0
  newPage = printTitle()
End Function

Private Sub printResults()
  Dim x As Single, y As Single, ss As String, xx As Single, i As Integer
  
  newPage
  x = 0
  pr.Font = fGrain
  pr.FontSize = fsGrain
  pr.FontItalic = True
  sPrint "FIT OPTION: Best-fit peaks using the binomial model of Galbraith and Green", x, cy
  pr.FontItalic = False
  
  pr.FontBold = True
  ss = "INITIAL GUESS FOR MODEL PARAMETERS (number of peaks to fit =" + Str(PkNum) + ")"
  sPrint ss, (ww - pr.TextWidth(ss)) / 2, cy + 0.5 * pr.TextHeight("0")
  pr.FontBold = False
  
  y = cy + 0.5 * pr.TextHeight("0")
  ss = "Peak #.  Peak Age     Theta    Fraction(%)    Count"
  xx = pr.TextWidth(ss)
  x = (ww - xx) / 2
  sPrint ss, x, y
  pr.Line (x, cy)-(x + xx, cy)
  cy = cy + 0.2 * pr.TextHeight("0")
  For i = 1 To PkNum
    ss = nFormat(i, 0, 6) + ".  "
    ss = ss + nFormat(binom.cPkAge(i), 2, 8) + "  "
    ss = ss + nFormat(binom.cPkTheta(i), 3, 8) + "  "
    ss = ss + nFormat(binom.cPkFract(i), 1, 12) + "  "
    ss = ss + nFormat(binom.cPkCount(i), 2, 8)
    sPrint ss, x, cy
  Next i
  pr.Line (x, cy)-(x + xx, cy)
  cy = cy + 0.5 * pr.TextHeight("0")
  ss = "Total range for grain ages:                    " + Format(AgeMin, " ####0.0") + "  to  " + Format(AgeMax, "####0.0") + " Ma"
  x = (ww - pr.TextWidth(ss)) / 2
  sPrint ss, x, cy
  sPrint "Number of active grains (Num. used for fit):   " + Str(Num), x, cy
  sPrint "Number of removed grains:                      " + Str(data.remCount), x, cy
  sPrint "Degrees of freedom for fit:                    " + Str(peaks(PkNum).DF), x, cy
  sPrint "Average of the SE(Z)'s for the grains:          " + Format(Round(peaks(PkNum).QMeanZerr, 2)), x, cy
  sPrint "Estimated width of peaks in PD plot in Z units: " + Format(Round(peaks(PkNum).EstPkWidth, 2)), x, cy
  
  x = 0
  pr.FontBold = True
  ss = "PARAMETERS FOR BEST-FIT PEAKS"
  sPrint ss, (ww - pr.TextWidth(ss)) / 2, cy + 1.5 * pr.TextHeight("0")
  pr.FontBold = False
  
  pr.FontItalic = True
  sPrint "*   Standard error for peak age includes group error", x, cy + 0.5 * pr.TextHeight("0")
  sPrint "*   Peak width is for PD plot assuming a kernel factor =  0.60", x, cy
  pr.FontItalic = False
  
  y = cy + 0.5 * pr.TextHeight("0")
  ss = " #. Peak Age(Ma)   68%CI            95%CI          W(Z)  Frac(%)  SE,%   Count"
  xx = pr.TextWidth(ss)
  x = (ww - xx) / 2
  sPrint ss, x, y
  pr.Line (x, cy)-(x + xx, cy)
  cy = cy + 0.2 * pr.TextHeight("0")
  Dim x1
  For i = 1 To PkNum
    ss = nFormat(i, 0, 2) + ". "
    ss = ss + nFormat(binom.cMean(i), 1, 7) + "  "
    ss = ss + center(binom.c68(i), 16) + "  "
    ss = ss + center(binom.c95(i), 16) + "  "
    ss = ss + nFormat(binom.cWZ(i), 2, 6) + "  "
    ss = ss + nFormat(binom.cFrac(i), 1, 6) + "  "
    ss = ss + nFormat(binom.cSE(i), 1, 5) + "  "
    ss = ss + nFormat(binom.cCount(i), 1, 6)
    sPrint ss, x, cy
  Next i
  pr.Line (x, cy)-(x + xx, cy)
  cy = cy + 0.5 * pr.TextHeight("0")
  sPrint "Log-likelihood for best fit:            " + binom.pVal(6), x, cy
  sPrint "Chi-squared value for best fit:         " + binom.pVal(7), x, cy
  sPrint "Reduced chi-squared value:              " + binom.pVal(8), x, cy
  sPrint "Probability for F test:                 " + binom.pVal(12), x, cy
  sPrint "Condition number for COVAR matrix:      " + binom.pVal(9), x, cy
  sPrint "Number of iterations:                   " + binom.pVal(10), x, cy
End Sub

Private Function center(ByVal ss As String, n As Integer) As String
  Dim k As Integer, k0 As Integer
  k = Len(ss)
  k0 = Int((n - k) / 2)
  If k0 > 0 Then
    center = Space(n - k - k0) + ss + Space(k0)
  ElseIf k0 = 0 Then
    center = Space(n - k) + ss
  Else
    center = Left(ss, n)
  End If
End Function

Private Sub printGrains()
  Dim ss As String, i As Integer, j As Integer
  Dim v1 As Single, v2 As Single, v3 As Single
  Dim x As Single, y As Single
  Dim Sqnum As Single
  Dim Ugrain As Single
  Dim Uerr As Single
  
  Dim NNs As Single, NNi As Single
  Dim SumNs As Single, SumNi As Single
  Dim SumSqnum As Single, SumSq As Single
  Dim k As Single

  Dim Theta As Single
  Dim ThetaVariance As Single
  Dim Term1 As Single, Term2 As Single
  Dim Chi2 As Single
  Dim DF As Integer
  Dim LowNs As Boolean
  Dim Q As Single
  
  Dim SumRhoS As Single, SumRhoI As Single, Usum As Single
  Dim PoolAge As Single, PoolAgeL68 As Single, PoolAgeU68 As Single
  Dim PoolAgeL95 As Single, PoolAgeU95 As Single
  Dim BetaCenAge As Single, RECenAge As Single, CenAgeDispersion As Single
  Dim CenAge As Single, CenAgeL68 As Single, CenAgeU68 As Single
  Dim CenAgeL95 As Single, CenAgeU95 As Single

  x = 0
  pr.Font = fGrain
  pr.FontSize = fsGrain
  pr.FontBold = True
  ss = "GRAIN AGES IN ORIGINAL ORDER"
  sPrint ss, (ww - pr.TextWidth(ss)) / 2, cy
  cy = cy + 0.5 * pr.TextHeight("0")
  pr.FontBold = False
  printGTitle x

  SumNs = 0
  SumNi = 0
  SumSqnum = 0
  SumSq = 0
  i = 0
  Do While Not data.fEOF()
    If wh < cy + pr.TextHeight("0") Then
      newPage
      printGTitle x
    End If
    ss = Trim(data.getLine(line))
    line = line + 1
    If ss <> "" And Left(ss, 1) <> ";" Then
      If getVal(ss, NNs, NNi, Sqnum) <> 0 Then
        ERR = 1: Exit Do
      End If
      If NNs < 0 Then
        newPage
        line = line - 1
        printParams
        printGTitle x
      Else
        i = i + 1
        Ns(i) = NNs
        Ni(i) = NNi
        SumSqnum = SumSqnum + Sqnum
        Zeta(i) = Zeta0
        REZeta(i) = REZeta0
        RhoD(i) = RhoD0
        RERhoD(i) = RERhoD0
        Uglass(i) = Uglass0
        Sq(i) = Sqnum * SqSize
        RhoS(i) = Ns(i) / Sq(i)
        RhoI(i) = Ni(i) / Sq(i)
        Call FTeqn(Ns(i), Ni(i), RhoD0, RERhoD0, Zeta0, REZeta0, 2, FTage(i), FTerrL(i), FTerrU(i))
        Zgrain(i) = log(LamdaD * Zeta0 * GF * RhoD0 * (Ns(i) + 0.5) / (Ni(i) + 0.5))
        Ugrain = Uglass(i) * RhoI(i) / RhoD(i)
        Uerr = Ugrain * 2 * Sqr((1 / (Ni(i) + 0.5)) + RERhoD(i) * RERhoD(i))
  
        y = cy
        sPrint nFormat(i, 0, 4) + "  ", x, y
        ss = Format(RhoS(i), "Scientific")
        sPrint Space(9 - Len(ss)) + ss, cx, y
        sPrint " (", cx, y
        sPrint nFormat(Ns(i), 0, 4) + ") ", cx, y
        ss = Format(RhoI(i), "Scientific")
        sPrint Space(9 - Len(ss)) + ss, cx, y
        sPrint " (", cx, y
        sPrint nFormat(Ni(i), 0, 4) + ")  ", cx, y
        sPrint nFormat(Sqnum, 0, 4) + "  ", cx, y
        If Uglass0 <> 0 Then
          sPrint nFormat(Ugrain, 0, 4) + " ", cx, y
          sPrint nFormat(Uerr, 0, 3) + " ", cx, y
        Else
          sPrint "---- --- ", cx, y
        End If
        sPrint nFormat(FTage(i), 1, 6) + " ", cx, y
        sPrint nFormat(FTerrL(i), 1, 6) + " ", cx, y
        sPrint nFormat(FTerrU(i), 1, 6), cx, y
        
        '... K factor corrects Ni in the Chi2 test to a common neutron fluence
        ' which is proportional to Zeta*RhoD. The size of the correction is
        ' usually very small, so that it makes little difference to the test.
        ' Note that the value for SumNi can be somewhat different than the actual
        ' sum of the Ni values shown in the grain-age-ordered table.
        k = (Zeta(1) * RhoD(1)) / (Zeta(i) * RhoD(i))
        SumNs = SumNs + Ns(i)
        SumNi = SumNi + Ni(i) * k
        SumSq = SumSq + Sq(i)
      End If
    End If
  Loop
  
  RhoD0 = RhoD(1)
  RERhoD0 = RERhoD(1)
  Zeta0 = Zeta(1)
  REZeta0 = REZeta(1)
  '... Calculate Chi Squared statistics.
  Theta = SumNs / (SumNs + SumNi)
  ThetaVariance = Theta * (1 - Theta)
  Chi2 = 0
  LowNs = False
  '... Num should equal the total active grains loaded above
  For j = 1 To Num
    k = (Zeta0 * RhoD0) / (Zeta(j) * RhoD(j))
    '... check for low expected counts in Ns
    If Theta * (Ns(j) + Ni(j) * k) < 5 Then
      LowNs = True
    End If
    
    Term1 = Ns(j) - Theta * (Ns(j) + Ni(j) * k)
    Term2 = ThetaVariance * (Ns(j) + Ni(j) * k)
    
    '... Check to see if denominator is zero, in which case SumNs =0,
    ' and the term as well should be zero.
    If Term2 > 0 Then
      Chi2 = Chi2 + Term1 * Term1 / Term2
    End If
  Next j
  
  DF = i - 1  '... Degrees of freedom = number of grains - 1
  Q = GammQ(DF / 2, Chi2 / 2) * 100
  
  pr.Line (x, cy)-(cx, cy)
  cy = cy + 0.3 * pr.TextHeight("0")
  
  '... Print summary results
  SumRhoS = SumNs / SumSq
  SumRhoI = SumNi / SumSq
  Usum = Uglass0 * SumRhoI / RhoD0
  Uerr = 2 * Usum * Sqr((1 / SumNi) + RERhoD0 * RERhoD0)
  
  '... Calculate age and uncertainties for pooled age
  Call FTeqn(SumNs, SumNi, RhoD0, RERhoD0, Zeta0, REZeta0, 1, PoolAge, PoolAgeL68, PoolAgeU68)
  Call FTeqn(SumNs, SumNi, RhoD0, RERhoD0, Zeta0, REZeta0, 2, PoolAge, PoolAgeL95, PoolAgeU95)
  
  '... Calculate age and uncertainties for central age
  Call CentralAge(BetaCenAge, RECenAge, CenAgeDispersion)
  CenAgeL95 = TaufromBeta(BetaCenAge - 1.96 * RECenAge)
  CenAgeL68 = TaufromBeta(BetaCenAge - RECenAge)
  CenAge = TaufromBeta(BetaCenAge)
  CenAgeU68 = TaufromBeta(BetaCenAge + RECenAge)
  CenAgeU95 = TaufromBeta(BetaCenAge + 1.96 * RECenAge)
  
  y = cy
  sPrint "POOLED", x, y
  ss = Format(SumRhoS, "Scientific")
  sPrint Space(9 - Len(ss)) + ss, cx, y
  sPrint "(", cx, y
  sPrint nFormat(SumNs, 0, 5), cx, y
  sPrint ") ", cx, y
  ss = Format(SumRhoI, "Scientific")
  sPrint Space(9 - Len(ss)) + ss, cx, y
  sPrint "(", cx, y
  sPrint nFormat(SumNi, 0, 5), cx, y
  sPrint ") ", cx, y
  sPrint nFormat(SumSqnum, 0, 5) + " ", cx, y
  If Not ZMethodFlag% Then
     sPrint nFormat(Usum, 0, 5), cx, y
     sPrint nFormat(Uerr, 0, 4) + " ", cx, y
  Else
     sPrint " ---- --- ", cx, y
  End If
  sPrint nFormat(PoolAge, 1, 6) + " ", cx, y
  sPrint nFormat(PoolAgeL95, 1, 6) + " ", cx, y
  sPrint nFormat(PoolAgeU95, 1, 6), cx, y
  
  If wh < cy + 9 * pr.TextHeight("0") Then
    newPage
    y = cy
  Else
    y = cy + pr.TextHeight("0")
  End If
  sPrint "CHI^2 PROBABILITY (%):", x, y
  sPrint nFormat(Q, 1, 5), cx, y
  y = cy
  If LowNs Then
    sPrint " >>> Beware: possible upward bias in Chi^2 probability due to low counts <<<", x, y
  End If
  
  y = cy + pr.TextHeight("0")
  sPrint " POOLED AGE W/  68% CONF. INTERVAL(Ma): ", x, y
  sPrint nFormat(PoolAge, 1, 6) + ", ", cx, y
  sPrint nFormat(PoolAgeL68, 1, 5) + " -- ", cx, y
  sPrint nFormat(PoolAgeU68, 1, 5) + " (", cx, y
  sPrint nFormat(PoolAgeL68 - PoolAge, 1, 5) + " ", cx, y
  sPrint nFormat(PoolAgeU68 - PoolAge, 1, 5, "+") + ")", cx, y
  y = cy
  sPrint "                95% CONF. INTERVAL(Ma):         ", x, y
  sPrint nFormat(PoolAgeL95, 1, 5) + " -- ", cx, y
  sPrint nFormat(PoolAgeU95, 1, 5) + " (", cx, y
  sPrint nFormat(PoolAgeL95 - PoolAge, 1, 5) + " ", cx, y
  sPrint nFormat(PoolAgeU95 - PoolAge, 1, 5, "+") + ")", cx, y
  y = cy + pr.TextHeight("0")
  sPrint "CENTRAL AGE W/  68% CONF. INTERVAL(Ma): ", x, y
  sPrint nFormat(CenAge, 1, 6) + ", ", cx, y
  sPrint nFormat(CenAgeL68, 1, 5) + " -- ", cx, y
  sPrint nFormat(CenAgeU68, 1, 5) + " (", cx, y
  sPrint nFormat(CenAgeL68 - CenAge, 1, 5) + " ", cx, y
  sPrint nFormat(CenAgeU68 - CenAge, 1, 5, "+") + ")", cx, y
  y = cy
  sPrint "                95% CONF. INTERVAL(Ma):         ", x, y
  sPrint nFormat(CenAgeL95, 1, 5) + " -- ", cx, y
  sPrint nFormat(CenAgeU95, 1, 5) + " (", cx, y
  sPrint nFormat(CenAgeL95 - CenAge, 1, 5) + " ", cx, y
  sPrint nFormat(CenAgeU95 - CenAge, 1, 5, "+") + ")", cx, y
  y = cy
  sPrint "                    AGE DISPERSION (%):  ", x, y
  sPrint nFormat(100 * CenAgeDispersion, 1, 5), cx, y

End Sub

Sub CentralAge(BetaCenAge As Single, RECenAge As Single, CenAgeDispersion As Single)
'============================================================================
'... Calculate central age and standard error, using the algorithm
' of Galbraith and Laslett (1993, Nuclear Tracks, v. 21, p.459-470).
' Start by making initial estimates for ThetaCenAge and SE(ThetaCenAge).
'... Additional input parameters
' Num% (shared) = number of dated grains
' Ns() (shared) = number of spontaneous tracks counted per grain
' Ni() (shared) = number of induced tracks counted per grain
' Zeta0 and REZeta0 (shared) = base zeta constant and relative error
' RhoD0 and RERhoD0 (shared) = base monitor track density and relative error
' Zeta() (shared) = zeta constant for each grain
' RhoD() (shared) = monitor track density for each grain
' Zgrain() (shared) = z transformed grain age
'============================================================================
'... Sum to find pooled counts
' K factor corrects Ni proportional to Zeta*RhoD. The size of the
' correction is usually very small, so it has only a minor effect on
' the central age calculation.
  Dim SumNs As Single, SumNt As Single, SumZ As Single, SumZ2 As Single
  Dim i As Integer, j As Integer
  Dim k As Single, ThetaCenAge As Single, LastThetaCenAge As Single
  Dim LastCenAgeDispersion As Single
  Dim SumW As Single, SumThetaCenAge As Single, SumCenAgeDispersion As Single
  Dim Mj As Single, Yj As Single, Term As Single, Wj As Single, RSE2 As Single

  SumNs = 0
  SumNt = 0
  SumZ = 0
  SumZ2 = 0
  For i = 1 To Num
    k = (Zeta0 * RhoD0) / (Zeta(i) * RhoD(i))
    SumNs = SumNs + Ns(i)
    SumNt = SumNt + Ns(i) + Ni(i) * k
    SumZ = SumZ + Zgrain(i)
    SumZ2 = SumZ2 + Zgrain(i) * Zgrain(i)
  Next i
  ThetaCenAge = SumNs / SumNt
  CenAgeDispersion = 0.6 * Sqr(((Num * SumZ2) - SumZ * SumZ) / (1! * Num * (Num - 1)))
  LastThetaCenAge = 0
  LastCenAgeDispersion = 0
  Do
    SumW = 0
    SumThetaCenAge = 0
    SumCenAgeDispersion = 0
    For j = 1 To Num
        k = (Zeta0 * RhoD0) / (Zeta(j) * RhoD(j))
        Mj = Ns(j) + Ni(j) * k
        Yj = Ns(j) / Mj
        Term = ThetaCenAge * (1 - ThetaCenAge) * CenAgeDispersion
        Wj = Mj / (ThetaCenAge * (1 - ThetaCenAge) + (Mj - 1) * Term * Term)
        SumW = SumW + Wj
        SumThetaCenAge = SumThetaCenAge + Wj * Yj
        Term = Wj * (Yj - ThetaCenAge)
        SumCenAgeDispersion = SumCenAgeDispersion + Term * Term
    Next j
    ThetaCenAge = SumThetaCenAge / SumW
    CenAgeDispersion = CenAgeDispersion * Sqr(SumCenAgeDispersion / SumW)
    If Abs((ThetaCenAge - LastThetaCenAge) / ThetaCenAge) < 0.0001 And Abs(CenAgeDispersion - LastCenAgeDispersion) < 0.001 Then
        Exit Do
    Else
        LastThetaCenAge = ThetaCenAge
        LastCenAgeDispersion = CenAgeDispersion
    End If
Loop

'... Transform theta to beta
BetaCenAge = log(ThetaCenAge / (1 - ThetaCenAge))

'... Calculate standard error for estimated Theta
Term = ThetaCenAge * (1 - ThetaCenAge)
RSE2 = 1 / (Term * Term * SumW)
RECenAge = Sqr(RSE2 + REZeta0 * REZeta0 + RERhoD0 * RERhoD0)
End Sub

Static Function GammQ(a As Single, x As Single) As Single
Dim GamSER As Single, GammCF As Single, GLN As Single
  If (x < 0) Or (a <= 0) Then
    GammQ = 1
    Exit Function
  End If
  If x < (a + 1) Then
    Call Gser(GamSER, a, x, GLN)
    GammQ = 1 - GamSER
  Else
    Call Gcf(GammCF, a, x, GLN)
    GammQ = GammCF
  End If
End Function

Static Sub Gcf(GammCF As Single, a As Single, x As Single, GLN As Single)
Const ITMAX% = 100, EPS = 0.0000003
Dim GOLD As Single, A0 As Single, A1 As Single, B0 As Single, B1 As Single
Dim FAC As Single, An As Integer, n As Integer, ANA As Single, ANF As Single
Dim G1 As Single

GLN = GammLn(1# * a)
GOLD = 0
A0 = 1
A1 = x
B0 = 0
B1 = 1
FAC = 1
For n = 1 To ITMAX
        An = n
        ANA = An - a
        A0 = (A1 + A0 * ANA) * FAC
        B0 = (B1 + B0 * ANA) * FAC
        ANF = An * FAC
        A1 = x * A0 + ANF * A1
        B1 = x * B0 + ANF * B1
        If A1 <> 0 Then
                FAC = 1 / A1
                G1 = B1 * FAC
                If Abs((G1 - GOLD) / G1) < EPS Then Exit For
                GOLD = G1
        End If
Next n

If n > ITMAX Then
        MsgBox "*** A is too large, ITMAX is too small ***"  '!!!
        Stop
End If

GammCF = Exp(-x + a * log(x) - GLN) * G1
End Sub

Static Sub Gser(GamSER As Single, a As Single, x As Single, GLN As Single)
  Const ITMAX% = 100, EPS = 0.0000003
  Dim AP As Single, Sum As Single, DEL As Single, n As Integer

  GLN = GammLn(1# * a)
  If x < 0 Then Stop
  If x = 0 Then
    GamSER = 0
    Exit Sub
  End If
  AP = a
  Sum = 1 / a
  DEL = Sum
  For n = 1 To ITMAX
    AP = AP + 1
    DEL = DEL * x / AP
    Sum = Sum + DEL
    If Abs(DEL) < Abs(Sum) * EPS Then Exit For
  Next n
  If n > ITMAX Then
    MsgBox "*** A is too large, ITMAX is too small ***"   '!!!
    Stop
  End If

  GamSER = Sum * Exp(-x + a * log(x) - GLN)
End Sub

Private Sub printParams()
  Dim ss As String, n As Integer
  Dim v1 As Single, v2 As Single, v3 As Single
  Dim x As Single
  
  ZMethodFlag% = False
  n = 2
  Do While Not data.fEOF()
    ss = Trim(data.getLine(line))
    line = line + 1
    If ss <> "" And Left(ss, 1) <> ";" Then
      If getVal(ss, v1, v2, v3) <> 0 Then
        ERR = 1: Exit Do
      End If
      If n = 2 And v1 >= 0 Then
        ERR = 1: Exit Do
      End If
      Select Case n
        Case 2:
          RhoD0 = Abs(v1)
          If RhoD0 <> 1 Then
            RERhoD0 = Abs(v2) / 100
            Uglass0 = Abs(v3)
          Else
            RERhoD0 = 0
            Uglass0 = 0
            ZMethodFlag% = True
          End If
        Case 3:
          Zeta0 = v1: REZeta0 = v2: SqSize = v3
          REZeta0 = REZeta0 / Zeta0
      End Select
      n = n + 1
    End If
    If n > 3 Then Exit Do
  Loop
  If n < 4 Then
    ERR = 1
  Else
    x = 0
    pr.Font = fParam
    pr.FontSize = fsParam
    If RERhoD0 <> 0 Then
      pr.FontBold = True
      ss = "NEW PARAMETERS - ZETA METHOD"
      sPrint ss, (ww - pr.TextWidth(ss)) / 2, cy
      cy = cy + 0.5 * pr.TextHeight("0")
      pr.FontBold = False
      sPrint "EFFECTIVE TRACK DENSITY FOR FLUENCE MONITOR (tracks/cm^2): " + Format(RhoD0, "Scientific"), x, cy
      sPrint "                                       RELATIVE ERROR (%): " + Format(RERhoD0 * 100, "##0.00"), x, cy
      sPrint "               EFFECTIVE URANIUM CONTENT OF MONITOR (ppm): " + Format(Uglass0, "###0.00"), x, cy
      sPrint "                 ZETA FACTOR AND STANDARD ERROR (yr cm^2): " + Format(Zeta0, "###0.00") + "   " + Format(REZeta0 * Zeta0, "##0.00"), x, cy
      sPrint "                            SIZE OF COUNTER SQUARE (cm^2): " + Format(SqSize, "Scientific"), x, cy
    Else
      pr.FontBold = True
      ss = "NEW PARAMETERS - Z METHOD"
      sPrint ss, (ww - pr.TextWidth(ss)) / 2, cy
      cy = cy + 0.5 * pr.TextHeight("0")
      pr.FontBold = False
      sPrint "         Z FACTOR AND STANDARD ERROR (yr): " + Format(Zeta0, "Scientific") + Format(REZeta0 * Zeta0, "Scientific"), x, cy
      sPrint "            SIZE OF COUNTER SQUARE (cm^2): " + Format(SqSize, "Scientific"), x, cy
    End If
    cy = cy + pr.TextHeight("0")
  End If
End Sub

Private Function getVal(ByVal ss As String, ByRef v1 As Single, ByRef v2 As Single, ByRef v3 As Single)
  Dim ERR As Integer, k As Integer, i As Integer, s1 As String
  
  ERR = 0
  k = InStr(ss, ",")
  If k = 0 Then k = InStr(ss, " ")
  i = 1
On Error GoTo Errr
  While k > 0 And i <= 3
    s1 = Left(ss, k - 1)
    ss = LTrim(Mid(ss, k + 1))
    Select Case i
      Case 1: v1 = val(Trim(Left(s1, k - 1)))
      Case 2: v2 = val(Trim(Left(s1, k - 1)))
      Case 3: v3 = val(Trim(Left(s1, k - 1)))
    End Select
    k = InStr(ss, ",")
    If k = 0 Then k = InStr(ss, " ")
    i = i + 1
  Wend
  If i < 3 Then
    ERR = 1
  ElseIf i = 3 Then
    If ss = "" Then ERR = 1 Else v3 = val(Trim(ss))
  End If
  getVal = ERR
GoTo Done
Errr:
  getVal = 1
Done:
End Function

Private Sub printPlots()
  Dim x0 As Single, W As Single, H As Single, hTitle As Single
  Dim hFont As Single, hPic As Single
  
  newPage
  hTitle = cy
  hFont = pr.TextHeight("0")
  
  Clip.gClip.ScaleMode = 1
  W = Clip.gClip.Width
  H = Clip.gClip.Height
  
  If Clip.gClip.Width <= ww Then
    x0 = (ww - Clip.gClip.Width) / 2
  Else
    x0 = wx0
    Clip.gClip.Width = ww
    Clip.gClip.Height = (Clip.gClip.Height / W) * Clip.gClip.Width
  End If

  If (2 * Clip.gClip.Height + 3 * hFont) > (wh - hTitle) Then
    Clip.gClip.Height = 0.5 * (wh - hTitle - 3 * hFont)
    Clip.gClip.Width = (W / H) * Clip.gClip.Height
    x0 = (ww - Clip.gClip.Width) / 2
  End If
  hPic = Clip.gClip.Height
  
  If Num > 0 Then
    'page 1
    grPlot.show Clip.gClip, PkNum, False, 2
    pr.PaintPicture Clip.gClip.Image, x0, cy

    cy = hTitle + hPic + 2 * hFont
    PDplot.show Clip.gClip, True, 2, 2
    pr.PaintPicture Clip.gClip.Image, x0, cy
    'page 2
    newPage
    radPlot.show Clip.gClip, 2
    pr.PaintPicture Clip.gClip.Image, x0, cy

    cy = hTitle + hPic + 2 * hFont
    PFplot.show Clip.gClip, 2
    pr.PaintPicture Clip.gClip.Image, x0, cy
    
  End If
  Clip.gClip.Width = W
  Clip.gClip.Height = H
End Sub

