VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "dataFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'ToDo:
' include zCalc to setData and remove array Ni0()

Option Explicit

'CLASS: dataFiles
'----------------
'
'PUBLIC:
'  properties
    Public fCount As Integer       'number of loaded data files
'   fName(n)                        name of loaded file number n
'   fTitle(n)                       title of loaded file number n
    Public remCount As Integer     'number of removed grains
'  methods
'   total() as integer              total number of grains (with removed)
'   fOpen(ff) as boolean            load file ff
'   remGrain(n) as boolean          remove grain n
'   undo() as boolean               undo last removed grain
'   getText(Label As String) as string       return loaded data in text format (for view or save)
'   saveFTZ(file)
'   saveBFT(file)
'   savePRB(file)
'   savePLT(file)
'   savePF(file)
'
'   getLine(n) as string        return first line (n=1) or next line (n<>1) from fData
'   fEOF() as boolean           return True if no next line in fData
'
'PRIVATE:
'  variables:
    Private fileName(1 To MaxFiles) As String  'list of loaded file names
    Private fileTitle(1 To MaxFiles) As String 'list of loaded file labels
    Private fData As String                    'loaded DataSet in text format
    Private fLine As Long                      'next line position into fData
    Private lenData As Long                    'length of fData
    'removed grains
    Private Const maxRemGrains = 50            'max count of grains which can be removed
    Private remPos(1 To maxRemGrains) As Long  'list of removed grains (list of numbers)
    'messages
    Private Const msgMaxGrains = "Too many grains!" + vbCrLf + "Maximum number of grains = "
    Private Const msgCannotOpen = "Cannot open file:" + vbCrLf
    Private Const msgCannotSave = "Cannot save file:" + vbCrLf
'  methods:
'   getLabel() as string        return label of dataset
'   fGet(file) as boolean       load data from file
'   fAdd(file) as boolean       add data from file
'   setData()                   initial calculate of loaded data
'   zCalc()                     initial calculate of loaded data (calling from setData)
'   correct(string) as string   correct different format of input data file (" " or "," delimiter)
'   getTitle(string) as string  return title for output files
'

Public Function TOTAL() As Integer
  TOTAL = Num + remCount
End Function

Public Function remgrain(n As Integer) As Boolean
  Dim i As Integer
  Dim sout As String
  Dim ss As String
  Dim cc As String

  If remCount < maxRemGrains Then
    sout = getLine(1) + vbCrLf
    i = 0
    Do While Not fEOF()
      ss = Trim(getLine())
      If ss <> "" Then
        cc = Left(ss, 1)
        If cc <> ";" Then
          If cc = "-" Then
            sout = sout + ss + vbCrLf
            ss = getLine()
            sout = sout + ss + vbCrLf
          Else
            i = i + 1
            If i = n Then
              remCount = remCount + 1
              remPos(remCount) = Len(sout) + 1
              toLogLine "# remove grain: " + Format(grainAge(n), "####0.00") + " Ma"
              sout = sout + ";" + ss + vbCrLf
            Else
              sout = sout + ss + vbCrLf
            End If
          End If
        Else
          sout = sout + ss + vbCrLf
        End If
      End If
    Loop
    fData = sout
    setData
    remgrain = True
    Exit Function
  Else
    remgrain = False
  End If
End Function

Public Function undo() As Boolean
  Dim n As Long

  undo = False
  If remCount > 0 Then
    n = remPos(remCount)
    If Mid(fData, n, 1) = ";" Then
      fData = Left(fData, n - 1) + Mid(fData, n + 1)
      remCount = remCount - 1
      toLogLine "# undo remove grain"
      setData
      undo = True
    End If
  End If
End Function

Public Property Let fName(n As Integer, ss As String)
  fileName(n) = ss
End Property

Public Property Get fName(n As Integer) As String
  fName = fileName(n)
End Property

Public Property Let fTitle(n As Integer, ss As String)
  fileTitle(n) = ss
End Property

Public Property Get fTitle(n As Integer) As String
  fTitle = fileTitle(n)
End Property

Private Function fGet(file As String) As Boolean
  Dim n As Long

  On Error GoTo Ferr
  Open file For Binary As #1
  fData = Space(LOF(1))
  Get #1, , fData
  Close #1
  n = InStrRev(fData, vbLf)
  If n > 0 Then
    If Len(fData) - n < 5 Then fData = Left(fData, n)
    If Right(fData, 1) <> vbLf Then fData = fData + vbCrLf
  End If
  lenData = Len(fData)
  fCount = fCount + 1
  fName(fCount) = file
  fTitle(fCount) = getLine(1)
  fGet = True
  Exit Function
Ferr:
  MsgBox msgCannotOpen + file, vbOKOnly + vbExclamation, progname
  fGet = False
End Function

Private Function fAdd(file As String) As Boolean
  Dim ss As String
  Dim n As Long

  On Error GoTo Ferr
  Open file For Binary As #1
  ss = Space(LOF(1))
  Get #1, , ss
  Close #1
  n = InStrRev(ss, vbLf)
  If n > 0 Then
    If Len(ss) - n < 5 Then ss = Left(ss, n)
    If Right(ss, 1) <> vbLf Then ss = ss + vbCrLf
  End If
  fCount = fCount + 1
  fName(fCount) = file
  n = InStr(ss, vbCrLf)
  If n = 0 Then n = InStr(ss, vbLf)
  If n > 0 Then fTitle(fCount) = Left(ss, n - 1) Else fTitle(fCount) = ss
  fData = fData + ";" + vbCrLf + ";" + ss
  lenData = Len(fData)
  fAdd = True
  Exit Function
Ferr:
  MsgBox msgCannotOpen + file, vbOKOnly + vbExclamation, progname
  fAdd = False
End Function

Public Function getLine(Optional k As Integer) As String
  Dim n As Long, i As Integer

  If k = 1 Then
    fLine = 1
  ElseIf fLine = -1 Then
    getLine = ""
    Exit Function
  ElseIf k > 0 Then
    fLine = 1
    For i = 2 To k
      fLine = InStr(fLine, fData, vbCrLf) + 2
    Next i
  End If
  n = InStr(fLine, fData, vbCrLf)
  If n > 0 Then
    getLine = Mid(fData, fLine, n - fLine)
    fLine = n + 2
    If fLine = lenData Then fLine = -1
  Else
    n = InStr(fLine, fData, vbLf)
    If n > 0 Then
      getLine = Mid(fData, fLine, n - fLine)
      fLine = n + 1
      If fLine = lenData Then fLine = -1
    Else
      getLine = Mid(fData, fLine)
      fLine = -1
    End If
  End If
End Function

Public Function fEOF() As Boolean
  If fLine = -1 Then fEOF = True Else fEOF = False
End Function

Public Function fOpen(file As String) As Boolean
  If fCount = 0 Then
    sLog = ""
    If fGet(file) = 0 Then
      fOpen = False
'      data.remCount = 0
      toLogLine "# ERROR: open file '" + file + "'"
      Exit Function
    Else
'      data.remCount = 0
      toLogLine "# open file '" + file + "'"
    End If
    data.remCount = 0
  ElseIf fAdd(file) = 0 Then
    fOpen = False
    toLogLine "# ERROR: add file '" + file + "'"
    Exit Function
  Else
    toLogLine "# add file '" + file + "'"
  End If
  setData
  toLogLine "  count =" + Str(Num) + " grains, range: " + Format(AgeMin, "###0.00") + " - " + Format(AgeMax, "####0.00") + " Ma"
  fOpen = True
End Function

Private Function dSplit(ByVal ss As String, ByRef arr() As String)
  Dim skip As Integer, k As Integer, i As Integer
  
  ReDim arr(0 To 3)
  skip = 0
      k = InStr(ss, ",")
      i = 0
      While k > 0 And i < 3
        arr(i) = Trim(Left(ss, k - 1))
        ss = Mid(ss, k + 1)
        k = InStr(ss, ",")
        i = i + 1
      Wend
      If i <= 1 Then
        skip = 1
      ElseIf i = 2 Then
        If Trim(ss) = "" Then skip = 1 Else arr(i) = Trim(ss)
      End If
  dSplit = skip
End Function

Private Sub setData()
  Dim line As Integer, i As Integer, skip As Integer
  Dim arr() As String, ss As String
  Dim NNs, NNi, Sqnum

  Dim Zmax As Single, Zmin As Single
  Dim RhoD As Single, RERhoD As Single
  Dim Zeta As Single, REZeta As Single
  Dim k As Single
  Dim title As String

  Num = 0
  Zmax = -10000
  Zmin = 10000
  QMeanZerr = 0

  title = getLine(1)    'line 1 - title
  line = 2
  Do While Not fEOF()
    skip = 0
    ss = getLine()
    If Trim(ss) <> "" And Left(ss, 1) <> ";" Then
      ss = correct(ss)
 '     arr = Split(ss, ",", 3)
      skip = dSplit(ss, arr())
      If skip = 0 Then
        NNs = val(arr(0))
        NNi = val(arr(1))
        Sqnum = val(arr(2))
        If val(arr(0)) < 0 Then line = 2
        Select Case line
          Case 2
            RhoD = Abs(NNs)
            If RhoD <> 1 Then
              RERhoD = Abs(NNi) / 100
              Uglass0 = Abs(Sqnum)
            Else
              RERhoD = 0
              Uglass0 = 0
            End If
          Case 3
            Zeta = NNs
            REZeta = NNi
            SqSize = Sqnum
            REZeta = REZeta / Zeta
            If Num = 0 Then
              Zeta0 = Zeta
              REZeta0 = REZeta
              RhoD0 = RhoD
              RERhoD0 = RERhoD
            End If
            k = (Zeta0 * RhoD0) / (Zeta * RhoD)
          Case Else
            If Num < maxGrains Then
              Num = Num + 1
              NNi = k * NNi
              Ni0(Num) = NNi
              Ns(Num) = CInt(NNs)
              Ni(Num) = CInt(NNi)
              Nt(Num) = CInt(NNs + NNi)
            Else
              MsgBox msgMaxGrains + Str(maxGrains), vbOKOnly + vbExclamation, progname
              Exit Do
            End If
        End Select
      End If
      line = line + 1
    End If
  Loop
  zCalc
End Sub

Private Sub zCalc()
  Dim i As Integer
  Dim NNs As Single, NNi As Single
  AgeMax = 0
  AgeMin = 50000
  QMeanZerr = 0
  For i = 1 To Num
    NNs = Ns(i) + 0.5
    NNi = Ni0(i) + 0.5
    Zgrain(i) = log(LamdaD * Zeta0 * GF * RhoD0 * NNs / NNi)
    Zerr(i) = Sqr(1 / NNs + 1 / NNi)
    QMeanZerr = QMeanZerr + Zerr(i) * Zerr(i)
    grainAge(i) = TaufromZ(Zgrain(i))
    If grainAge(i) > AgeMax Then AgeMax = grainAge(i)
    If grainAge(i) < AgeMin Then AgeMin = grainAge(i)
  Next i
  QMeanZerr = Sqr(QMeanZerr / (1! * Num))
  EstPkWidth = PkWidthFactor * QMeanZerr
End Sub

Private Function correct(ss As String) As String
  Dim cc As String, i As Integer, k As Integer, sss As String
  k = 1
  sss = ""
  For i = 1 To Len(ss)
    cc = Mid(ss, i, 1)
    If k = 1 Then
      If InStr(" ,", cc) = 0 Then
        k = 0
        sss = sss + cc
      End If
    ElseIf InStr(" ,", cc) > 0 Then
      k = 1
      sss = sss + ","
    Else
      sss = sss + cc
    End If
  Next
  correct = sss
End Function

Private Function getTitle(tt As String) As String
  Dim ss As String
  Dim j As Integer
  ss = APP.title + " ver." + Format(APP.Major) + "." + Format(APP.Minor) + vbCrLf
  ss = ss + "[" + Format(Date, "mm/dd/yyyy") + " " + Format(Time, "Short Time") + "]    " + tt + vbCrLf
'  ss = ss + getlabel() + vbCrLf
  ss = ss + fTitle(1) + vbCrLf
  For j = 1 To data.fCount
    ss = ss + "File: " + data.fName(j) + vbCrLf
  Next j
  getTitle = ss
End Function

Private Function getlabel() As String
  If data.fCount > 1 Then
    If data.remCount > 0 Then
      getlabel = "Merged and edited dataset: [enter a new title here for merged and edited data]"
    Else
      getlabel = "Merged dataset: [enter a new title here for merged data]"
    End If
  ElseIf data.remCount > 0 Then
    getlabel = "Edited datafile: [enter a new title here for edited data]"
  Else
    getlabel = fTitle(1)
  End If
End Function

Public Function getText(Label As String)
  Dim ss As String
  Dim i As Integer
  Dim tmp As String
  
  If Label = "" Then ss = getlabel() Else ss = Label
  ss = ss + vbCrLf
  If fCount > 1 Then
    ss = ss + ";Merged data files:" + vbCrLf
    For i = 1 To fCount
      ss = ss + ";   " + fTitle(i) + vbCrLf
    Next i
  End If
  If remCount > 0 Then
    ss = ss + ";Deleted grains are flagged as comment lines below." + vbCrLf
    ss = ss + ";   Total grains deleted =" + Str(remCount) + "." + vbCrLf
  End If
  If fCount > 1 Or remCount > 0 Then
    ss = ss + ";Data to follow" + vbCrLf + ";" + fData
  Else
    tmp = getLine(1)
    ss = ss + Mid(fData, fLine)
  End If
  getText = ss
End Function

Public Sub saveFTZ(out As String, Label As String)
  Dim ss As String
  ss = getText(Label)
  On Error GoTo Ferr
  Open out For Output As #2
  '... Put #2, , ss   >> left garbage at end of file
  Print #2, ss
  Close #2
  remCount = 0
  fCount = 1
  fName(fCount) = out
  fTitle(fCount) = Label
  toLogLine "# Save datafile as " + out
  Exit Sub
Ferr:
  MsgBox msgCannotSave + out, vbOKOnly + vbExclamation, progname
End Sub

Public Sub saveBFT(out As String)
  Dim ss As String
  Dim i As Integer

  ss = getTitle("Main results") + vbCrLf

  ss = ss + "FIT OPTION: Best-fit peaks using the binomial model of Galbraith and Green" + vbCrLf
  ss = ss + vbCrLf
  ss = ss + "INITIAL GUESS FOR MODEL PARAMETERS (number of peaks to fit =" + Str(PkNum) + ")" + vbCrLf
  ss = ss + vbCrLf
  ss = ss + "Peak #.  Peak Age     Theta    Fraction,%  Count" + vbCrLf
  ss = ss + "-------  --------  --------  ------------  -----" + vbCrLf
  For i = 1 To PkNum
    ss = ss + nFormat(i, 0, 6) + "."
    ss = ss + nFormat(binom.cPkAge(i), 2, 10)
    ss = ss + nFormat(PkTheta0(i), 3, 10)
    ss = ss + nFormat(PkFrac0(i) * 100, 1, 14)
    ss = ss + nFormat(PkFrac0(i) * Num, 2, 7) + vbCrLf
  Next i
  ss = ss + "------------------------------------------------" + vbCrLf
  ss = ss + "Total range for grain ages:                     " + binom.pVal(1) + " Ma" + vbCrLf
  ss = ss + "Number of active grains:                        " + binom.pVal(2) + vbCrLf
  ss = ss + "Number of removed grains:                       " + binom.pVal(11) + vbCrLf
  ss = ss + "Degrees of freedom for fit:                     " + binom.pVal(3) + vbCrLf
  ss = ss + "Average of the SE(Z)'s for the grains:          " + binom.pVal(4) + vbCrLf
  ss = ss + "Estimated width of peaks in PD plot in Z units: " + binom.pVal(5) + vbCrLf
  ss = ss + vbCrLf

  ss = ss + "PARAMETERS FOR BEST-FIT PEAKS" + vbCrLf
  ss = ss + "*   Standard error for peak age includes group error" + vbCrLf
  ss = ss + "*   Peak width is for PD plot assuming a kernel factor =  0.60" + vbCrLf
  ss = ss + vbCrLf
  ss = ss + " #.  Peak,Ma       68%CI             95%CI          W(Z)  Frac,%   SE,%   Count" + vbCrLf
  ss = ss + "---  -------  ----------------  ----------------  ------  ------  -----  ------" + vbCrLf
  For i = 1 To PkNum
    ss = ss + nFormat(i, 0, 2) + ".  "
    ss = ss + sRight(binom.cMean(i).Caption, 7)
    ss = ss + "  " + sCenter(binom.c68(i).Caption, 16)
    ss = ss + "  " + sCenter(binom.c95(i).Caption, 16)
    ss = ss + "  " + sCenter(binom.cWZ(i).Caption, 6)
    ss = ss + "  " + sCenter(binom.cFrac(i).Caption, 6)
    ss = ss + "  " + sCenter(binom.cSE(i).Caption, 5)
    ss = ss + "  " + sCenter(binom.cCount(i).Caption, 6) + vbCrLf
  Next i
  ss = ss + "-------------------------------------------------------------------------------" + vbCrLf
  ss = ss + "Log-likelihood for best fit:          " + binom.pVal(6) + vbCrLf
  ss = ss + "Chi-squared value for best fit:       " + binom.pVal(7) + vbCrLf
  ss = ss + "Reduced chi-squared value:            " + binom.pVal(8) + vbCrLf
  ss = ss + "Probability for F test:               " + binom.pVal(12) + vbCrLf
  ss = ss + "Degrees of freedom for fit:           " + binom.pVal(3) + vbCrLf
  ss = ss + "Condition number for covar matrix:    " + binom.pVal(9) + vbCrLf
  ss = ss + "Number of iterations:                 " + binom.pVal(10) + vbCrLf
   
  On Error GoTo Ferr
  Open out For Output As #2
  '... Put #2, , ss  >> left garbage at end of file
  Print #2, ss
  Close #2
  Exit Sub
Ferr:
  MsgBox msgCannotSave + out, vbOKOnly + vbExclamation, progname
End Sub

Public Sub savePRB(out As String)
  On Error GoTo ERR
  Open out For Output As #2
  '...Put #2, , getTitle("PD plot") + vbCrLf + PDplot.getData() >> left garbage at end of file
  Print #2, getTitle("PD plot")
  Print #2, PDplot.getData()
  Close #2
  Exit Sub
ERR:
  MsgBox msgCannotSave + out, vbOKOnly + vbExclamation, progname
End Sub

Public Sub savePLT(out As String)
  On Error GoTo ERR
  Open out For Output As #2
  '... Put #2, , getTitle("Radial plot") + vbCrLf + radPlot.getData()  >> left garbage at end of file
  Print #2, getTitle("Radial plot")
  Print #2, radPlot.getData()
  Close #2
  Exit Sub
ERR:
  MsgBox msgCannotSave + out, vbOKOnly + vbExclamation, progname
End Sub

Public Sub savePF(out As String)
  On Error GoTo ERR
  Open out For Output As #2
  '... Put #2, , getTitle("P(F) plot") + vbCrLf + PFplot.getData() >> left garbage at end of file
  Print #2, getTitle("P(F) plot")
  Print #2, PFplot.getData()
  Close #2
  Exit Sub
ERR:
  MsgBox msgCannotSave + out, vbOKOnly + vbExclamation, progname
End Sub

