VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "editGrains"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Class: editGrains
'
'properties:
'  count        - number of removed grains
'methods:
'  del(n)       - remove grain n
'  undo()       - undo last removed grain
'  getAge(n)    - return age of removed n-grain
'  getNumber(n) - return number of removed n-grain
'--------------------------------------------------------------------------
'use public vars: Num, grainAge(), Ns(), Ni(), Nt(), Ni0()

Option Explicit

Public count As Integer

Private Const maxRemGrains = 50  'max count of grains which can be removed
Private number(1 To maxRemGrains) As Integer
Private remAge(1 To maxRemGrains) As Double
Private remNs(1 To maxRemGrains) As Double
Private remNi(1 To maxRemGrains) As Double
Private remNt(1 To maxRemGrains) As Double
Private remNi0(1 To maxRemGrains) As Double


Public Function found(n As Integer) As Boolean
  Dim i As Integer
  For i = 1 To count
    If number(i) = n Then
      found = True
      Exit Function
    End If
  Next i
End Function


Public Function del(n As Integer) As Boolean
  Dim i As Integer
  Dim k As Integer

  If count < maxRemGrains Then
    count = count + 1
    number(count) = n
    remAge(count) = grainAge(n)
    remNs(count) = Ns(n)
    remNi(count) = Ni(n)
    remNt(count) = Nt(n)
    remNi0(count) = Ni0(n)
    For i = 1 To Num - 1
      If i >= n Then
        k = i + 1
        grainAge(i) = grainAge(k)
        Ns(i) = Ns(k)
        Ni(i) = Ni(k)
        Nt(i) = Nt(k)
        Ni0(i) = Ni0(k)
      End If
    Next i
    Num = Num - 1
    del = True
  Else
    del = False
  End If

End Function


Public Function undo() As Boolean
  Dim n As Integer
  Dim i As Integer
  Dim k As Integer

  If count = 0 Then
    undo = False
  Else
    n = number(count)
    For i = Num To n Step -1
      k = i + 1
      grainAge(k) = grainAge(i)
      Ns(k) = Ns(i)
      Ni(k) = Ni(i)
      Nt(k) = Nt(i)
      Ni0(k) = Ni0(i)
    Next i
    grainAge(n) = remAge(count)
    Ns(n) = remNs(count)
    Ni(n) = remNi(count)
    Nt(n) = remNt(count)
    Ni0(n) = remNi0(count)
    count = count - 1
    Num = Num + 1
    undo = True
  End If
End Function


Public Function getAge(n As Integer) As Double
  getAge = remAge(n)
End Function


Public Function getNumber(n As Integer) As Integer
  getNumber = number(n)
End Function

