VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "grainsPlot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'class: grainsPlot
'-----------------

' --------------------- plot depended --------------------------------
'public
' methods:
'  show(                         show grains plot _
         PictureBox, _
         peaksCombination, _
         CIshow, _
         plotMode               0-Screen, 1-Copy, 2-Print _
        )
'  getPlotName()
'  getGrain() as integer  - return number of grain (for remove)
   'for MouseMove event
'  cGrain(x,y) as string  - return current grain number for stattus bar
'  cAge(x,y) as string    - return current Age for stattus bar
'
'private
' methods:
'   Sub Xscale(pic As PictureBox, Label As String, xmin As Single, xmax As Single)
'   Sub Lscale(pic As PictureBox, Label As String, ymin As Single, ymax As Single)
'   Sub Rscale(pic As PictureBox, Label As String, ymin As Single, ymax As Single)
' vars:
   Private cx As Single
   Private cy As Single
   Private xmin As Single
   Private ymin As Single
   Private xmax As Single
   Private ymax As Single
   'labels:
   Private Const plotName = "Plot of Grain Ages (Unsorted)"
   Private Const xLabel = "Location of grain age in data file"
   Private Const yLeft = "Grain ages and best-fit peaks (Ma)"
   Private Const yRight = ""
   Private Const plotName2 = "Plot of Grain Ages (Sorted)"
   Private Const xLabel2 = "Rank in grain-age distribution"
   'colors:
   Private Const colGrain = &HFF0000
   Private Const colPeak = &HFF&
   Private Const colCI = &HC0C0FF
'
' --------------------- plot undepended --------------------------------
'private
' methods:
'   Sub init(pic As PictureBox)
'   Function getY0(pic As PictureBox)
'   Function getYY(pic As PictureBox)
'   Function getX0(pic As PictureBox)
'   Function getXX(pic As PictureBox)
'   Sub drawTitle(pic As PictureBox, name As String)
'   Sub drawAxis(pic As PictureBox)
'   Sub setScale(pic As PictureBox, x0 As Single, xx As Single, y0 As Single, yy As Single)
' vars:
   Private mode As Integer   'plot Mode
   'colors:
   Private Const colBack = &H80000005
   Private Const colFill = &H80000005
   'font:
   Private Const Font = "Times New Roman"
   Private Const screenFontSize = 10
   Private Const printFontSize = 14
   Private hFont As Single
   'window:
   Private psize As Single
   Private dh2 As Single
   Private dw2 As Single
   Private Const cScreen = 3
   Private Const cCopy = 2
   Private Const cPrint = 4
   Private Const cTopScreen = 0.17
   Private Const cTopCopy = 0.25
   Private Const cTopPrint = 0.38
'

' --------------------- plot depended methods --------------------------------

Public Function getPlotName() As String
  getPlotName = plotName
End Function

Public Function getGrain() As Integer
  getGrain = CInt(cx)
End Function

Public Function cAge(x As Single, y As Single) As String
  If x >= xmin And y >= ymin And x <= xmax And y <= ymax Then
    cx = x
    cy = y
    cAge = "Age: " + Format(cy, "####0")
  Else
    cAge = ""
  End If
End Function

Public Function cGrain(x As Single, y As Single) As String
  If x >= xmin And y >= ymin And x <= xmax And y <= ymax Then
    cx = x
    cy = y
    cGrain = "Grain: " + Format(cx, "####0")
  Else
    cGrain = ""
  End If
End Function

Private Sub Xscale(pic As PictureBox, Label As String, ByVal xmin As Single, ByVal xmax As Single)
  Dim x As Single, dx As Single, ds As Single, dd As Single
  Dim cx As Single, cy As Single, i As Single
  
  x = xmax - xmin
  dx = 10
  While x >= 10 * dx
    dx = dx * 2
  Wend
  ds = psize / xmax * dx
  dd = 0.25 * hFont
  cx = getX0(pic)
  cy = getY0(pic)
  For i = xmin To xmax Step dx
    pic.Line (cx, cy)-(cx, cy - dd)
    pic.CurrentX = cx - 0.6 * pic.TextWidth(Round(i))
    pic.CurrentY = cy - dd
    pic.Print Round(i)
    cx = cx + ds
  Next i
End Sub

Private Sub Lscale(pic As PictureBox, Label As String, ByVal ymin As Single, ByVal ymax As Single)
  Dim y As Single, dy As Single, ds As Single, dd As Single, dh As Single
  Dim cx As Single, cy As Single, i As Single
  Dim yText As New Rotator

  y = ymax - ymin
  dy = 10
  While y >= 10 * dy
    dy = dy * 2
  Wend
  ds = psize / ymax * dy
  dd = 0.5 * Abs(pic.TextWidth("0"))
  dh = 0.5 * hFont
  cx = getX0(pic)
  cy = getY0(pic)
  For i = ymin To ymax Step dy
    pic.Line (cx - dd, cy)-(cx, cy)
    pic.CurrentX = cx - dd - pic.TextWidth(Str(CInt(i)) + " ")
    pic.CurrentY = cy + dh
    pic.Print CInt(i)
    cy = cy + ds
  Next i
End Sub

Private Sub Rscale(pic As PictureBox, Label As String, ByVal ymin As Single, ByVal ymax As Single)
  Dim y As Single, dy As Single, ds As Single, dd As Single, dh As Single
  Dim cx As Single, cy As Single, i As Single
  Dim yText As New Rotator

  y = ymax - ymin
  dy = 10
  While y >= 10 * dy
    dy = dy * 2
  Wend
  ds = psize / ymax * dy
  dd = 0.5 * Abs(pic.TextWidth("0"))
  dh = 0.5 * hFont
  cx = getXX(pic)
  cy = getY0(pic)
  For i = ymin To ymax Step dy
    pic.Line (cx, cy)-(cx + dd, cy)
    pic.CurrentX = cx + dd
    pic.CurrentY = cy + dh
    pic.Print CInt(i)
    cy = cy + ds
  Next i
End Sub

Public Sub show(pic As PictureBox, _
                n As Integer, _
                CImode As Integer, _
                plotMode As Integer _
                )
  Dim i As Single
  Dim N1 As Integer, N2 As Integer
  Dim x0 As Single, y0 As Single, xx As Single, yy As Single
  Dim x As Single, y As Single

  mode = plotMode   ' 0-Screen, 1-Copy, 2-Print
  init pic
  If mode = 2 Then drawTitle pic, plotName
  drawAxis pic
  Xscale pic, xLabel, 0, Num + 1
  Lscale pic, yLeft, 0, AgeMax * 1.05
  Rscale pic, yRight, 0, AgeMax * 1.05
  setScale pic, 0, Num + 1, 0, AgeMax * 1.05

  x0 = 0: y0 = 0: xx = Num + 1: yy = AgeMax * 1.05
  x = xx - x0
  y = yy - y0
  N1 = 1:  N2 = 2  ' 68% CI
'  N1 = 3:  N2 = 4  ' 95% CI

  'show CI
  If CImode = 0 Then
    For i = 1 To PkNum
      pic.Line (x0, peaks(n).calc(i) + peaks(n).SEPkAge(i, N1))-(xx, peaks(n).calc(i) + peaks(n).SEPkAge(i, N2)), colCI, BF
    Next i
  End If
  ' show grains
  For i = 1 To Num
    pic.Line (i, y0)-(i, grainAge(i)), colGrain
  Next i
  ' show peaks
  For i = 1 To PkNum
    pic.Line (x0, peaks(n).calc(i))-(xx, peaks(n).calc(i)), colPeak
  Next i

  'box
  pic.FillStyle = 1
  pic.Line (x0, y0)-(xx, yy), , B

  xmin = x0: xmax = xx
  ymin = y0: ymax = yy
End Sub

' --------------------- plot undepended methods --------------------------------

Private Sub init(pic As PictureBox)
  Dim hh As Single

  pic.Cls
  pic.Font = Font
  If mode = 0 Then
    pic.Font.Size = screenFontSize
  Else
    pic.Font.Size = printFontSize
  End If
  pic.FillStyle = 0
  pic.BackColor = colBack
  pic.FillColor = colFill
  pic.ScaleMode = 0    'custom
  pic.Scale (0, pic.Height)-(pic.Width, 0)
  hh = Abs(pic.ScaleHeight)
  hFont = Abs(pic.TextHeight("0"))
  If mode = 0 Then                                  'screen
    psize = hh - cScreen * hFont
  ElseIf mode = 1 Then                              'copy
    psize = hh - cCopy * hFont
  ElseIf mode = 2 Then                              'print
    psize = hh - cPrint * hFont
  End If
  dh2 = (hh - psize) / hh
  dw2 = (pic.ScaleWidth - psize) / pic.ScaleWidth
End Sub
  
Private Function getY0(pic As PictureBox)
  Dim hh As Single

  hh = Abs(pic.ScaleHeight)
  If mode = 0 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopScreen)
  ElseIf mode = 1 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopCopy)
  ElseIf mode = 2 Then
    getY0 = pic.ScaleTop - hh + (hh * dh2) * (1 - cTopPrint)
  End If
End Function

Private Function getYY(pic As PictureBox)
  Dim hh As Single

  hh = Abs(pic.ScaleHeight)
  If mode = 0 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopScreen
  ElseIf mode = 1 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopCopy
  ElseIf mode = 2 Then
    getYY = pic.ScaleTop - (hh * dh2) * cTopPrint
  End If
End Function

Private Function getX0(pic As PictureBox)
  getX0 = pic.ScaleLeft + (pic.ScaleWidth * dw2) / 2
End Function

Private Function getXX(pic As PictureBox)
  getXX = pic.ScaleLeft + pic.ScaleWidth - (pic.ScaleWidth * dw2) / 2
End Function

Private Sub drawTitle(pic As PictureBox, name As String)
  pic.Font.Size = 1.1 * printFontSize
  pic.Font.Bold = True
  pic.CurrentX = (pic.ScaleWidth - pic.TextWidth(name)) / 2
  pic.CurrentY = pic.ScaleTop
  pic.Print name
  pic.Font.Size = printFontSize
  pic.Font.Bold = False
End Sub

Private Sub drawAxis(pic As PictureBox)
  Dim yText As New Rotator

  pic.Line (getX0(pic), getY0(pic))-(getXX(pic), getYY(pic)), , B
  If mode <> 1 Then
    'X
    pic.CurrentX = pic.ScaleLeft + (pic.ScaleWidth - pic.TextWidth(xLabel)) / 2
    pic.CurrentY = 1.2 * hFont
    pic.Print xLabel
    ' Left
    Set yText.Device = pic
    yText.Angle = 90
    pic.CurrentY = getY0(pic) + (psize - pic.TextWidth(yLeft)) / 2
    pic.CurrentX = 0.2 * hFont
    yText.Label yLeft
    ' Right
    Set yText.Device = pic
    yText.Angle = 90
    pic.CurrentY = getY0(pic) + (psize - pic.TextWidth(yRight)) / 2
    pic.CurrentX = pic.ScaleWidth - 1.2 * hFont
    yText.Label yRight
  End If
End Sub

Private Sub setScale(pic As PictureBox, ByVal x0 As Single, ByVal xx As Single, ByVal y0 As Single, ByVal yy As Single)
  Dim dx As Single, dy As Single

  dx = (xx - x0) * dw2 / (1 - dw2)
  dy = (yy - y0) * dh2 / (1 - dh2)
  If mode = 0 Then
    pic.Scale (x0 - dx / 2, yy + cTopScreen * dy)-(xx + dx / 2, y0 - (1 - cTopScreen) * dy)
  ElseIf mode = 1 Then
    pic.Scale (x0 - dx / 2, yy + cTopCopy * dy)-(xx + dx / 2, y0 - (1 - cTopCopy) * dy)
  ElseIf mode = 2 Then
    pic.Scale (x0 - dx / 2, yy + cTopPrint * dy)-(xx + dx / 2, y0 - (1 - cTopPrint) * dy)
  End If
  hFont = Abs(pic.TextHeight("0"))
End Sub

