Attribute VB_Name = "pkFind"
Option Explicit
Public Const resTitle = "  Init.Age  Calc.Age    DF       X^2     rX^2         F   P(F)       BIC"
Public isAuto As Integer

Public Inum As Integer     'number of initial peaks
Public Ipeaks() As Single  'initial peaks

Public Type peaksType
  count As Integer
  init(1 To PFmax) As Single
  PkTheta0(1 To PFmax) As Single
  PkFrac0(1 To PFmax) As Single

  calc(1 To PFmax) As Single
  SEPkAge(1 To PFmax, 1 To 4) As Single
  PkSDz(1 To PFmax) As Single
  PkFrac(1 To PFmax) As Single
  SEPkFrac(1 To PFmax) As Single

  DF As Integer

  QMeanZerr As Single
  EstPkWidth As Single
  LogLike As Single
  Cnumb As Single
  Iter As Integer

  X2 As Single
  rX2 As Single
  pX2 As Single
  f As Single
  pF As Single
End Type

Public peaks(0 To PFmax) As peaksType

Public Sub selPeaks()            'select initial peaks
  Dim i As Integer

  If Num > 0 Then
    SelectPeaks.show 1
    If isAuto > 0 Then
      toLog "# select peaks: "
      For i = 1 To Inum
        toLog "  " + Format(Ipeaks(i), "###0.00")
      Next i
      toLog vbCrLf
    End If
  End If
End Sub

Private Sub setPkInit(ByVal n As Integer, init() As Single)
  Dim i As Integer
  Dim k As Integer

  For i = 1 To n
    peaks(i).count = i
    For k = 1 To i
      peaks(i).init(k) = init(k)
    Next k
  Next i
End Sub

Public Sub ManCalc(ByVal n As Integer, init() As Single)
  Dim i As Integer

  toLogLine "# manual calculation:"
  toLogLine resTitle
  isAuto = 2
  setPkInit n, init()
  For i = 1 To n
    binom.StatusBar.Panels(1).Text = "Calculation:" + Str(i)
    peaks(i).count = i
    calc i
    toLogLine getResult(i, "  ")
  Next i
End Sub

Public Sub calc(n As Integer)
  Dim i As Integer
  PkNum = peaks(n).count
  For i = 1 To PkNum
    PkAge(i) = peaks(n).init(i)
  Next i
  PkCalc
  setResult n, peaks()
End Sub

Public Sub setResult(n As Integer, pk() As peaksType)
  Dim i As Integer, j As Integer

  For i = 1 To PkNum
    pk(n).calc(i) = PkAge(i)
    pk(n).PkTheta0(i) = PkTheta0(i)
    pk(n).PkFrac0(i) = PkFrac0(i)
    For j = 1 To 4
      pk(n).SEPkAge(i, j) = SEPkAge(i, j)
    Next j
    pk(n).PkSDz(i) = PkSDz(i)
    pk(n).PkFrac(i) = PkFrac(i)
    pk(n).SEPkFrac(i) = SEPkFrac(i)
  Next i
  pk(n).QMeanZerr = QMeanZerr
  pk(n).EstPkWidth = EstPkWidth
  pk(n).LogLike = LogLike
  pk(n).Cnumb = Cnumb
  pk(n).Iter = Iter

  pk(n).X2 = ChiSq
  pk(n).DF = Num - (2 * PkNum - 1)
  pk(n).rX2 = pk(n).X2 / pk(n).DF
  If PkNum = 1 Then
    pk(n).pF = 0
  Else
    pk(n).f = (pk(n - 1).X2 - pk(n).X2) / (pk(n).X2 / pk(n).DF)
    If pk(n).X2 >= pk(n - 1).X2 Then
      pk(n).pF = 100
    Else
      pk(n).pF = getPF(pk(n - 1).X2, pk(n - 1).DF, pk(n).X2, pk(n).DF)
    End If
  End If
End Sub

Public Function getResult(n As Integer, sp As String) As String
  Dim j As Integer
  Dim ss As String
  Dim BIC As Single
  ss = ""
  For j = 1 To peaks(n).count
    ss = ss + sp + nFormat(peaks(n).init(j), 2, 8)
    ss = ss + "  " + nFormat(peaks(n).calc(j), 2, 8)
    If j = PkNum Then
      BIC = -2 * peaks(n).LogLike + (2 * PkNum - 1) * log(Num)
      ss = ss + "  " + nFormat(peaks(n).DF, 0, 4)
      ss = ss + "  " + nFormat(peaks(n).X2, 2, 8)
      ss = ss + "  " + nFormat(peaks(n).rX2, 3, 7)
      ss = ss + "  " + nFormat(peaks(n).f, 3, 8)
      ss = ss + "  " + nFormat(peaks(n).pF, 3, 4)
      ss = ss + "  " + nFormat(BIC, 3, 8)
    End If
    ss = ss + vbCrLf
  Next j
  getResult = ss
End Function

